class Tracer
{
   static var info;
   static var trace;
   static var _traceBox;
   static var traceProperties;
   static var error;
   function Tracer()
   {
   }
   static function Init(rootMC)
   {
      var traceBox;
      traceBox = rootMC.createTextField("traceBox",11000,0,10,150,400);
      with(traceBox)
      {
         backgroundColor = 16777215;
         background = true;
         multiline = true;
         wordWrap = true;
         html = true;
      }
      var traceBoxFormat = new TextFormat();
      traceBoxFormat.font = "Courier";
      traceBoxFormat.size = 12;
      traceBox.setNewTextFormat(traceBoxFormat);
      Tracer._traceBox = traceBox;
      rootMC.tr = function(obj)
      {
         var _loc3_ = "\n";
         var _loc2_ = 0;
         while(_loc2_ < arguments.length)
         {
            _loc3_ += String(arguments[_loc2_]);
            if(_loc2_ != arguments.length - 1)
            {
               _loc3_ += ", ";
            }
            _loc2_ = _loc2_ + 1;
         }
         rootMC.traceBox.text += _loc3_;
         traceBox.scroll = traceBox.maxscroll;
      };
      rootMC.trprops = function(obj)
      {
         rootMC.traceBox.text += "\n---Trace props of: " + String(obj);
         for(var _loc2_ in obj)
         {
            rootMC.traceBox.text += "\n" + String(_loc2_) + ":" + String(obj[_loc2_]);
         }
         traceBox.scroll = traceBox.maxscroll;
      };
      rootMC.err = function(obj)
      {
         var _loc1_ = String(obj);
         rootMC.traceBox.htmlText += "\n<b>" + _loc1_ + "</b>";
         traceBox.scroll = traceBox.maxscroll;
      };
      Tracer.trace = mx.utils.Delegate.create(rootMC,rootMC.tr);
      Tracer.traceProperties = mx.utils.Delegate.create(rootMC,rootMC.trprops);
      Tracer.info = Tracer.trace;
      Tracer.error = mx.utils.Delegate.create(rootMC,rootMC.err);
      Tracer.trace("---Start tracing---");
      var btnToggleVisible;
      btnToggleVisible = rootMC.createEmptyMovieClip("btnToggleVisible",11001);
      with(btnToggleVisible)
      {
         _x = 0;
         _y = 0;
         beginFill(16776960);
         lineStyle(0,16777215);
         moveTo(0,0);
         lineTo(10,0);
         lineTo(10,10);
         lineTo(0,10);
         lineTo(0,0);
      }
      btnToggleVisible.onPress = function()
      {
         rootMC.traceBox._visible = !rootMC.traceBox._visible;
      };
      var btnClearTrace;
      btnClearTrace = rootMC.createEmptyMovieClip("btnClearTrace",11002);
      with(btnClearTrace)
      {
         _x = 12;
         _y = 0;
         beginFill(16711935);
         lineStyle(0,16777215);
         moveTo(0,0);
         lineTo(10,0);
         lineTo(10,10);
         lineTo(0,10);
         lineTo(0,0);
      }
      btnClearTrace.onPress = function()
      {
         rootMC.traceBox.text = "";
      };
   }
   static function Show()
   {
      if(Tracer._traceBox != undefined)
      {
         Tracer._traceBox._visible = true;
      }
   }
   static function Hide()
   {
      if(Tracer._traceBox != undefined)
      {
         Tracer._traceBox._visible = false;
      }
   }
}
